#include "Element.h"

using namespace graphic;

//  constructor
Element::Element(int r, int c, std::vector < StatisticalValue * > stats) : IsoObject(r, c)
{
	// number of passed stats
	int num_stats = stats.size();

	// store energy stat
	for(int i = 0; i < num_stats ; i++)
		_stats.push_back(stats[i]);
}

// full constructor
Element::Element(int r, int c, std::vector < Image * > views, std::vector < StatisticalValue * > stats) : IsoObject(r, c)
{
	// store views
	for(int i = 0; i < NUM_VIEWS; i++)
		_views.push_back(views[i]);

	// set default view
	_img = _views[SOUTH];

	// number of passed stats
	int num_stats = stats.size();

	// store energy stat
	for(int i = 0; i < num_stats ; i++)
		_stats.push_back(stats[i]);

	// default orientation
	_direction = SOUTH;
}

// destroyer
Element::~Element()
{
	int num_del = _stats.size();

	// delete all stats
	for(int i = 0; i < num_del; i++)
		delete _stats[i];

	_stats.clear();

	num_del = _views.size();
}

