#ifndef CLASS_STATISTICAL_VALUE
#define CLASS_STATISTICAL_VALUE


/// A single statistical value of an element
class StatisticalValue
{
	private:
	 /// top value
	 int _max;
	 /// current value
	 int _cur;

	public:
		/// constuctor
		StatisticalValue(int max)
		{
			_max = max;
			_cur = max;
		};
		/// full constructor
		StatisticalValue(int max, int cur)
		{
			_max = max;
			_cur = cur;
		};
		/// destroyer
		~StatisticalValue() {};

		/// return the max value
		int GetMax() { return _max; };
		/// set the max value
		void SetMax(int val) { _max = val; };
		/// add a value to the max
		void AddMax(int val) { _max += val; };
		/// subtract a value to the max
		void SubMax(int val)
		{
			if((_max - val) > 0)
				_max -= val;
			else
				_max = 0;
		};

		/// return the current value
		int GetCur() { return _cur; };
		/// set the current value
		void SetCur(int val)
		{
			if(val <= _max && val >= 0)
				_cur = val;
		};
		/// add a value to the current
		void AddCur(int val)
		{
			if(_cur + val <= _max)
				_cur += val;
			else
				_cur = _max;
		};
		/// subtract a value to the current
		void SubCur(int val)
		{
			if((_cur - val) > 0)
				_cur -= val;
			else
				_cur = 0;
		};

		/// restore the current value to the max value
		void RestoreCur() { _cur = _max; };
};

#endif
