#ifndef CLASS_GL_BLITTER
#define CLASS_GL_BLITTER

#include "Blitter.h"
#include "GLSurface.h"
#include "GLScreen.h"

namespace graphic
{
/// Surface blitting class (OpenGL)
class GLBlitter : public Blitter
{
	public:
	 /// Constructor
	 GLBlitter() {};
	 /// Destructor
	 ~GLBlitter() {};

	 // NULL -> NULL
	 /// Copy an entire surface on another one of the same size
	 void Copy(Surface * src, Surface * dest = NULL) {};

	 // NULL -> Rect
	 /// Blit an entire surface on another one using surface position
	 void Blit(Surface * src, Surface * dest = NULL);

	 // NULL -> Rect
	 /// blit an entire surface on another one NOT using surface position, but dest_rect one
	 void Blit(Surface * src, SDL_Rect & dest_rect, Surface * dest = NULL);

	 // Rect -> Rect
	 /// Blit part of a surface on another one using surface position for the destination
	 void BlitPart(Surface * src, SDL_Rect & src_rect, Surface * dest = NULL);

	 // Rect -> Rect
	 /// Blit part of a surface on part of another one NOT using surface position
	 /// for the destination, but dest_rect.x and dest_rect.y
	 void BlitPart(Surface * src, SDL_Rect & src_rect,
			   SDL_Rect & dest_rect, Surface * dest = NULL);

	 /// Blit the part of screen limited by src_rect on the dest surface
	 void SaveScreen(SDL_Rect & src_rect, Surface * dest) {};
	 /// Blit part of screen limited by src_rect on part of the dest surface
	 /// limited by dest_rect
	 void SaveScreen(SDL_Rect & src_rect, SDL_Rect & dest_rect, Surface * dest) {};
};

}
#endif
