#ifndef CLASS_GL_IMAGE
#define CLASS_GL_IMAGE

#include <string>

#include <SDL_image.h>

#include "GLSurface.h"
#include "Image.h"

namespace graphic
{
/// a surface loaded from an image file
class GLImage : public virtual GLSurface, public virtual Image
{
	private:
	 /// set visible limits of the image
	 void SetVisibleLimits();

	public:
	 /// base constructor, Create a new image from a file name
	 GLImage(std::string file);
	 /// create a new image from a file name setting a color as transparent
	 GLImage(std::string file, SDL_Color trans_color);
	 /// destructor
	 ~GLImage() { };

	 /// return true if the pixel at (x,y) is transparent, false otherwise
	 bool IsTrans(Uint16 x, Uint16 y);

	 /// set the opacity of the surface
	 void SetOpacity(Uint8 opacity)
	 {
	 	GLSurface::SetOpacity(opacity);
		SetVisibleLimits();
	 };
};

}
#endif
