#ifndef CLASS_GL_MOVABLE_IMAGE
#define CLASS_GL_MOVABLE_IMAGE

#include "Blitter.h"
#include "MovableImage.h"
#include "GLImage.h"
#include "GLMovableSurface.h"

namespace graphic
{

/// a movable surface loaded from an image file
class GLMovableImage :  public MovableImage, public GLMovableSurface, public GLImage
{
	public:
	 /// base constructor, Create a new image from a file name, by default no alpha
	 GLMovableImage(std::string file) : GLImage(file) { };
	 /// create a new image from a file name setting a color as transparent
	 GLMovableImage(std::string file, SDL_Color trans_color) : GLImage(file, trans_color) { };
	 /// destroyer
	 ~GLMovableImage() { };
};

}
#endif
