#ifndef CLASS_GL_SCREEN
#define CLASS_GL_SCREEN

#include "Screen.h"
#include <GL/gl.h>

namespace graphic
{

/// this is the screen (or window) where everything is blitted, it uses SDL to get an
/// available surface
class GLScreen : public Screen
{
	private:
	 /// init the whole GL graphic contest
	 void InitScreen();

	public:
	 /// constructor
	 GLScreen(Uint16 w, Uint16 h, Uint32 flags = SDL_OPENGL | SDL_FULLSCREEN);
	 /// destructor
	 virtual ~GLScreen() {};

	 /// set screen flags
	 void SetFlags(Uint32 flags);

	 /// set screen resolution
	 void SetResolution(Uint16 w, Uint16 h);

	 /// go in fullscreen mode
	 void GoFullScreen();
	 /// go in windowed mode
	 void GoWindowed();

	 /// update the entire screen
	 void Update() { SDL_GL_SwapBuffers(); };
	 /// update a given area of screen
	 void UpdateRect(SDL_Rect & rect) {};

	 /// fill the surface with a color
	 void Fill(SDL_Color & color);

	 /// clear the screen (fill with black, the default color)
	 void Clear() { glClear(GL_COLOR_BUFFER_BIT); };
};

}
#endif
