#ifndef CLASS_SDL_BLITTER
#define CLASS_SDL_BLITTER

#include "Blitter.h"
#include "SDLSurface.h"
#include "SDLScreen.h"

namespace graphic
{
/// Surface blitting class (SDL)
class SDLBlitter : public Blitter
{
	public:
	 /// constructor
	 SDLBlitter() {};
	 /// destroyer
	 ~SDLBlitter() {};

	 // NULL -> NULL
	 /// Copy an entire surface on another one of the same size
	 void Copy(Surface * src, Surface * dest = NULL);

	 // NULL -> Rect
	 /// Blit an entire surface on another one using surface position
	 void Blit(Surface * src, Surface * dest = NULL);

	 // NULL -> Rect
	 /// blit an entire surface on another one NOT using surface position, but dest_rect one
	 void Blit(Surface * src, SDL_Rect & dest_rect, Surface * dest = NULL);

	 // Rect -> Rect
	 /// Blit part of a surface on another one using surface position for the destination
	 void BlitPart(Surface * src, SDL_Rect & src_rect, Surface * dest = NULL) ;

	 // rect -> Rect
	 /// Blit part of a surface on part of another one NOT using surface position
	 /// for the destination, but dest_rect.x and dest_rect.y
	 void BlitPart(Surface * src, SDL_Rect & src_rect,
			   SDL_Rect & dest_rect, Surface * dest = NULL);

	 /// blit the part of screen limited by src_rect on the dest surface
	 void SaveScreen(SDL_Rect & src_rect, Surface * dest);
	 /// blit part of screen limited by src_rect on part of the dest surface
	 /// limited by dest_rect
	 void SaveScreen(SDL_Rect & src_rect, SDL_Rect & dest_rect, Surface * dest);
};

}
#endif
