#ifndef CLASS_SDL_MOVABLE_IMAGE
#define CLASS_SDL_MOVABLE_IMAGE

#include "Blitter.h"
#include "MovableImage.h"
#include "SDLImage.h"
#include "SDLMovableSurface.h"

namespace graphic
{

/// A surface loaded from an image file
class SDLMovableImage :  public MovableImage, public SDLMovableSurface, public SDLImage
{
	public:
	 /// base constructor, Create a new image from a file name, by default no alpha
	 SDLMovableImage(std::string file) : SDLImage(file)
	 {
		 _bk_surface = new SDLSurface(_rectangle->w, _rectangle->h,
									  						_surface->flags, false, _surface->format->BitsPerPixel);
	 };
	 /// create a new image from a file name setting a color as transparent
	 SDLMovableImage(std::string file, SDL_Color trans_color) : SDLImage(file, trans_color)
	 {
		 _bk_surface = new SDLSurface(_rectangle->w, _rectangle->h,
									  						_surface->flags, false, _surface->format->BitsPerPixel);
	 };
	 /// destroyer
	 ~SDLMovableImage() { };
};

}
#endif
