#include "SDLMovableSurface.h"

// Save background of Image before a blit
void graphic::SDLMovableSurface::SaveBackground(Surface * src_surf)
{
	// using a temporary rectangle to preserve data integrity
	SDL_Rect temp_r;

	temp_r.x = _rectangle->x;
	temp_r.y = _rectangle->y;
	temp_r.w = _rectangle->w;
	temp_r.h = _rectangle->h;

	// blit from screen
	if(src_surf == NULL)
		blitter->SaveScreen(temp_r, _bk_surface);
	// blit from a src_surface to _bk_surface
	else
	   blitter->Blit(src_surf, temp_r, _bk_surface);
}

// Update altered rectangle of screen
void graphic::SDLMovableSurface::UpdateScreen()
{
	// backup and update rectangles
	SDL_Rect bk_r, update_r;

	bk_r.x = _bk_surface->GetX();
	bk_r.y = _bk_surface->GetY();
	bk_r.w = _bk_surface->GetW();
	bk_r.h = _bk_surface->GetH();

	// get the minimum X,Y
	update_r.x = (_rectangle->x < bk_r.x) ? _rectangle->x : bk_r.x;
	update_r.y = (_rectangle->y < bk_r.y) ? _rectangle->y : bk_r.y;

	// calculate the movement along X axis
	if(_rectangle->x == bk_r.x)
		update_r.w = _rectangle->w;
	else
		update_r.w = abs(_rectangle->x - bk_r.x) + _rectangle->w;

	// calculate the movement along Y axis
	if(_rectangle->y == bk_r.y)
		update_r.h = _rectangle->h;
	else
		update_r.h = abs(_rectangle->y - bk_r.y) + _rectangle->h;

	// refresh screen
	screen->UpdateRect(update_r);

	// update bk_surface position
	_bk_surface->SetPosition(_rectangle->x, _rectangle->y);
}

