#ifndef CLASS_SDL_SCREEN
#define CLASS_SDL_SCREEN

#include "Screen.h"

namespace graphic
{

/// This is the screen (or window) where everything is blitted, it uses SDL to get an
/// available surface
class SDLScreen : public Screen
{
	public:
	 /// constructor
	 SDLScreen(Uint16 w, Uint16 h, Uint32 flags = SDL_SWSURFACE|SDL_FULLSCREEN);
	 /// destroyer
	 ~SDLScreen() { };

	 /// set screen flags
	 void SetFlags(Uint32 flags);

	 /// set screen resolution
	 void SetResolution(Uint16 w, Uint16 h);

	 /// go in fullscreen mode
	 void GoFullScreen();
	 /// go in windowed mode
	 void GoWindowed();

	 /// update the entire screen
	 void Update() { SDL_Flip(_surface); };
	 /// update a given area of screen
	 void UpdateRect(SDL_Rect & rect);

	 /// fill the surface with a color
	 void Fill(SDL_Color & color);

	 /// clear the screen ==> fill the surface with black color
	 void Clear() { SDL_FillRect(_surface, NULL, SDL_MapRGB(_surface->format, 0, 0, 0)); };

	 /// SDLBlitter is a friend of SDLScreen so to access to its data
	 friend class SDLBlitter;
};

}
#endif
